/*  Accesspoint - station communication without router
 *  see: https://github.com/esp8266/Arduino/blob/master/doc/esp8266wifi/soft-access-point-class.rst
 *       https://github.com/esp8266/Arduino/blob/master/doc/esp8266wifi/soft-access-point-examples.rst
 *       https://github.com/esp8266/Arduino/issues/504
 *  Works with: station_bare_01.ino
 */ 


#include <ESP8266WiFi.h>

WiFiServer server(80);
IPAddress IP(192,168,4,15);
IPAddress mask = (255, 255, 255, 0);

const byte numChars = 32;
char receivedChars[numChars];
char DataInChar[numChars];

boolean newData = false;

// byte ledPin = 2;

void setup() {
  Serial.begin(9600);
  WiFi.mode(WIFI_AP);
  WiFi.softAP("WS_AP", "WS_fab2019"); // SSID & password
  WiFi.softAPConfig(IP, IP, mask);
  server.begin();
  // pinMode(ledPin, OUTPUT);
  /* Serial.println();
  Serial.println("accesspoint_bare_01.ino");
  Serial.println("Server started.");
  Serial.print("IP: ");     Serial.println(WiFi.softAPIP());
  Serial.print("MAC:");     Serial.println(WiFi.softAPmacAddress());*/ 
}

void loop() {
  WiFiClient client = server.available();
  if (!client) {return;}
  // recvWithStartEndMarkers();
  // showNewData();
  // digitalWrite(ledPin, LOW);
  String WeatherData = client.readStringUntil('\r');
  // Serial.println("********************************");
  unsigned int lastStringLength = WeatherData.length();
  
  for(int i=lastStringLength; i<17; i++){
    WeatherData= WeatherData+' ';
  }

  //print each character in the string at a time
   for(int j=0; j<17; j++){
    Serial.println(WeatherData.charAt(j));
    delay(100);
  }
//  Serial.println(WeatherData + '\r');
  client.flush();
  // Serial.print("Byte sent to the station: ");
  // Serial.println(client.println(request + "ca" + "\r"));
  // digitalWrite(ledPin, HIGH);
  delay(1000);
  newData = false;
}

/* void recvWithStartEndMarkers() {
    static boolean recvInProgress = false;
    static byte ndx = 0;
    char startMarker = '<';
    char endMarker = '>';
    char rc[numChars];
 
    while (WiFi.status() == WL_CONNECTED && newData == false) {
        WiFiClient client = server.available(); // duplicated line to satisfy client in below line
        String StrToConvert = client.readStringUntil('\r');
        StrToConvert.toCharArray(DataInChar, 32);
        rc = DataInChar;

        if (recvInProgress == true) {
            if (rc != endMarker) {
                receivedChars[ndx] = rc;
                ndx++;
                if (ndx >= numChars) {
                    ndx = numChars - 1;
                }
            }
            else {
                receivedChars[ndx] = '\0'; // terminate the string
                recvInProgress = false;
                ndx = 0;
                newData = true;
            }
        }

        else if (rc == startMarker) {
            recvInProgress = true;
        }
    }
} */

/* void showNewData() {
    if (newData == true) {
        // Serial.print("This just in ... ");
        // Serial.println(receivedChars);
        // newData = false;
    }
} */
