/*  Accesspoint - station communication without router
 *  see: https://github.com/esp8266/Arduino/blob/master/doc/esp8266wifi/station-class.rst
 *  Works with: accesspoint_bare_01.ino
 */

#include <ESP8266WiFi.h>

byte ledPin = 2;
char ssid[] = "WS_AP";           // SSID of your AP
char pass[] = "WS_fab2019";         // password of your AP

const byte numChars = 32;
char receivedChars[numChars];

boolean newData = false;

IPAddress server(192,168,4,15);     // IP address of the AP


void setup() {
  Serial.begin(9600);
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, pass);           // connects to the WiFi AP
  // Serial.println();
  // Serial.println("Connection to the AP");
  while (WiFi.status() != WL_CONNECTED) {
    // Serial.print(".");
    delay(500);
  }
  /* Serial.println();
  Serial.println("Connected");
  Serial.println("station_bare_01.ino");
  Serial.print("LocalIP:"); Serial.println(WiFi.localIP());
  Serial.println("MAC:" + WiFi.macAddress());
  Serial.print("Gateway:"); Serial.println(WiFi.gatewayIP());
  Serial.print("AP MAC:"); Serial.println(WiFi.BSSIDstr());
  pinMode(ledPin, OUTPUT); */
}

void loop() {
  recvWithStartEndMarkers();
  // showNewData();
  WiFiClient client;
  client.connect(server, 80);
  // digitalWrite(ledPin, LOW);
  // Serial.println("********************************");
  // Serial.print("Byte sent to the AP: ");
  String WeatherData = receivedChars;
  client.print(WeatherData + '\r');
  // String answer = client.readStringUntil('\r');
  // Serial.println("From the AP: " + answer);
  client.flush();
  // digitalWrite(ledPin, HIGH);
  client.stop();
  delay(1000);
  newData = false;
}

void recvWithStartEndMarkers() {
    static boolean recvInProgress = false;
    static byte ndx = 0;
    char startMarker = '<';
    char endMarker = '>';
    char rc;
 
    while (Serial.available() > 0 && newData == false) {
        rc = Serial.read();

        if (recvInProgress == true) {
            if (rc != endMarker) {
                receivedChars[ndx] = rc;
                ndx++;
                if (ndx >= numChars) {
                    ndx = numChars - 1;
                }
            }
            else {
                receivedChars[ndx] = '\0'; // terminate the string
                recvInProgress = false;
                ndx = 0;
                newData = true;
            }
        }

        else if (rc == startMarker) {
            recvInProgress = true;
        }
    }
}

/* void showNewData() {
    if (newData == true) {
        // Serial.print("This just in ... ");
        // Serial.println(receivedChars);
        // newData = false;
    }
} */
